/***********************************************
 *
 * OG Script Dumper v3.0 by learn_more
 * File: out\a193\script\cam_dump.as
 * Generated: 29-Oct-2012 23:56:31
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3c8820 (0x7c8820)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xc2bd0 (0x4c2bd0)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xc2c00 (0x4c2c00)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c8ca0 (0x7c8ca0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3c93e0 (0x7c93e0)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c9170 (0x7c9170)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c9060 (0x7c9060)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c9440 (0x7c9440)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3c8f30 (0x7c8f30)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c8c50 (0x7c8c50)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c9410 (0x7c9410)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3c8cd0 (0x7c8cd0)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3c8e00 (0x7c8e00)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3c8870 (0x7c8870)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3c8370 (0x7c8370)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x2588b0 (0x6588b0)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x257740 (0x657740)
	void RemoveAll();		// 'Overgrowth.exe' + 0x257690 (0x657690)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x2577a0 (0x6577a0)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x2586c0 (0x6586c0)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x258730 (0x658730)
	void Update();		// 'Overgrowth.exe' + 0x25d050 (0x65d050)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x2bb180 (0x6bb180)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2bb130 (0x6bb130)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x38e210 (0x78e210)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x38e070 (0x78e070)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0x38e000 (0x78e000)
	float GetLens();		// 'Overgrowth.exe' + 0x38e050 (0x78e050)
	void Update();		// 'Overgrowth.exe' + 0x38e690 (0x78e690)
	bool valid();		// 'Overgrowth.exe' + 0x38c5d0 (0x78c5d0)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x19bd9b80
SphereCollision sphere_col;		// 0x19bd9b84
GUI gui;		// 0x1c9d7ec0
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x44e20c (0x84e20c)
CameraObject co;		// 0x1e804e28
CameraAnimationReader camera_animation_reader;		// 0x1e804f14
