/***********************************************
 *
 * OG Script Dumper v3.0 by learn_more
 * File: out\a193\script\playercontrol_dump.as
 * Generated: 29-Oct-2012 23:56:31
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// enemycontrol.as
	// aschar.as
	// situationawareness.as
	// interpdirection.as
	// aircontrols.as
	// fliproll.as
	// ledgegrab.as
	// playercontrol.as


/***********************************************
 * Global Functions:
 */

NavPath __cdecl GetPath(vec3, vec3)			// 'Overgrowth.exe' + 0x257c50 (0x657c50)
vec3 __cdecl NavRaycast(vec3, vec3)			// 'Overgrowth.exe' + 0x257640 (0x657640)
vec3 __cdecl NavPoint(vec3)			// 'Overgrowth.exe' + 0x257600 (0x657600)
void __cdecl SendMessage(int, int, vec3, vec3)			// 'Overgrowth.exe' + 0x258530 (0x658530)
void __cdecl SendMessage(int, string)			// 'Overgrowth.exe' + 0x259600 (0x659600)
vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3c8820 (0x7c8820)
float __cdecl GetAnimationEventTime( string &in, string &in )			// 'Overgrowth.exe' + 0x3a6620 (0x7a6620)


/***********************************************
 * Objects:
 */

class Level
{		// size: 0x0, flags:  asOBJ_REF
	int QueryIntFunction(string);		// 'Overgrowth.exe' + 0x3c55b0 (0x7c55b0)
	int GetNumObjectives();		// 'Overgrowth.exe' + 0x3c4db0 (0x7c4db0)
	int GetNumAchievements();		// 'Overgrowth.exe' + 0x3c4d80 (0x7c4d80)
	const string &GetObjective(int);		// 'Overgrowth.exe' + 0x3c5380 (0x7c5380)
	const string &GetAchievement(int);		// 'Overgrowth.exe' + 0x3c5290 (0x7c5290)
	void Execute(string);		// 'Overgrowth.exe' + 0x3c4de0 (0x7c4de0)
};

class NavPath
{		// size: 0x14, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	bool success;		// byteOffset: 0x10
//-----
	int NumPoints();		// 'Overgrowth.exe' + 0x3ca530 (0x7ca530)
	vec3 GetPoint(int);		// 'Overgrowth.exe' + 0x3ca550 (0x7ca550)
};

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xc2bd0 (0x4c2bd0)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xc2c00 (0x4c2c00)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c8ca0 (0x7c8ca0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3c93e0 (0x7c93e0)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c9170 (0x7c9170)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c9060 (0x7c9060)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c9440 (0x7c9440)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3c8f30 (0x7c8f30)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c8c50 (0x7c8c50)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c9410 (0x7c9410)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3c8cd0 (0x7c8cd0)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3c8e00 (0x7c8e00)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3c8870 (0x7c8870)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3c8370 (0x7c8370)
};

class CharacterScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x3c6910 (0x7c6910)
	string GetObjPath();		// 'Overgrowth.exe' + 0x3c6500 (0x7c6500)
	string GetSkeletonPath();		// 'Overgrowth.exe' + 0x3c64d0 (0x7c64d0)
	string GetAnimPath(string);		// 'Overgrowth.exe' + 0x3c6800 (0x7c6800)
	string GetAttackPath(string);		// 'Overgrowth.exe' + 0x3c66f0 (0x7c66f0)
	void GetTeamString(string &out);		// 'Overgrowth.exe' + 0x3c6530 (0x7c6530)
	float GetHearing();		// 'Overgrowth.exe' + 0x3c6490 (0x7c6490)
};

class ReactionScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x3c4280 (0x7c4280)
	string GetAnimPath(float);		// 'Overgrowth.exe' + 0x3c4250 (0x7c4250)
	int GetMirrored();		// 'Overgrowth.exe' + 0x3c4230 (0x7c4230)
};

class AttackScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x23eaf0 (0x63eaf0)
	string GetPath();		// 'Overgrowth.exe' + 0x23e4c0 (0x63e4c0)
	string GetSpecial();		// 'Overgrowth.exe' + 0x23e910 (0x63e910)
	string GetUnblockedAnimPath();		// 'Overgrowth.exe' + 0x23e9d0 (0x63e9d0)
	string GetBlockedAnimPath();		// 'Overgrowth.exe' + 0x23e9a0 (0x63e9a0)
	string GetThrowAnimPath();		// 'Overgrowth.exe' + 0x23e970 (0x63e970)
	string GetThrownAnimPath();		// 'Overgrowth.exe' + 0x23e940 (0x63e940)
	string GetThrownCounterAnimPath();		// 'Overgrowth.exe' + 0x23e4f0 (0x63e4f0)
	int IsThrow();		// 'Overgrowth.exe' + 0x23e5f0 (0x63e5f0)
	int GetHeight();		// 'Overgrowth.exe' + 0x23e900 (0x63e900)
	vec3 GetCutPlane();		// 'Overgrowth.exe' + 0x23e5d0 (0x63e5d0)
	int GetCutPlaneType();		// 'Overgrowth.exe' + 0x23e5c0 (0x63e5c0)
	bool HasCutPlane();		// 'Overgrowth.exe' + 0x23e5b0 (0x63e5b0)
	vec3 GetStabDir();		// 'Overgrowth.exe' + 0x23e590 (0x63e590)
	int GetStabDirType();		// 'Overgrowth.exe' + 0x23e580 (0x63e580)
	bool HasStabDir();		// 'Overgrowth.exe' + 0x23e570 (0x63e570)
	int GetDirection();		// 'Overgrowth.exe' + 0x23e8f0 (0x63e8f0)
	int GetSwapStance();		// 'Overgrowth.exe' + 0x23e8e0 (0x63e8e0)
	int GetSwapStanceBlocked();		// 'Overgrowth.exe' + 0x23e8d0 (0x63e8d0)
	int GetUnblockable();		// 'Overgrowth.exe' + 0x23e8c0 (0x63e8c0)
	int GetFleshUnblockable();		// 'Overgrowth.exe' + 0x23e560 (0x63e560)
	int GetAsLayer();		// 'Overgrowth.exe' + 0x23e550 (0x63e550)
	string GetAlternate();		// 'Overgrowth.exe' + 0x23e520 (0x63e520)
	string GetReactionPath();		// 'Overgrowth.exe' + 0x23e830 (0x63e830)
	string GetMaterialEvent();		// 'Overgrowth.exe' + 0x23e890 (0x63e890)
	vec3 GetImpactDir();		// 'Overgrowth.exe' + 0x23ea00 (0x63ea00)
	float GetBlockDamage();		// 'Overgrowth.exe' + 0x23e7b0 (0x63e7b0)
	float GetSharpDamage();		// 'Overgrowth.exe' + 0x23e730 (0x63e730)
	float GetDamage();		// 'Overgrowth.exe' + 0x23e6b0 (0x63e6b0)
	float GetForce();		// 'Overgrowth.exe' + 0x23e630 (0x63e630)
	int GetMirrored();		// 'Overgrowth.exe' + 0x23e4b0 (0x63e4b0)
	int GetMobile();		// 'Overgrowth.exe' + 0x23e620 (0x63e620)
};

class PathScriptReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	int GetNearestPoint(vec3);		// 'Overgrowth.exe' + 0x3c4970 (0x7c4970)
	vec3 GetPointPosition(int);		// 'Overgrowth.exe' + 0x3c4950 (0x7c4950)
	int GetConnectedPoint(int);		// 'Overgrowth.exe' + 0x3c4930 (0x7c4930)
	int GetOtherConnectedPoint(int, int);		// 'Overgrowth.exe' + 0x3c4910 (0x7c4910)
};



/***********************************************
 * Global Properties:
 */

Level level;		// 'Overgrowth.exe' + 0x555268 (0x955268)
int _plant_movement_msg;		// 'Overgrowth.exe' + 0x44e3b8 (0x84e3b8)
int _editor_msg;		// 'Overgrowth.exe' + 0x44e3bc (0x84e3bc)
ScriptParams params;		// 0x19a57bc4
ASCollisions col;		// 0x16164db8
SphereCollision sphere_col;		// 0x16164dbc
MovementObject this_mo;		// 0x19a57b50
int _at_grip;		// 'Overgrowth.exe' + 0x4d4f40 (0x8d4f40)
int _at_sheathe;		// 'Overgrowth.exe' + 0x4ce904 (0x8ce904)
uint8 _ANM_MIRRORED;		// 'Overgrowth.exe' + 0x4ce908 (0x8ce908)
uint8 _ANM_MOBILE;		// 'Overgrowth.exe' + 0x4ce909 (0x8ce909)
uint8 _ANM_SUPER_MOBILE;		// 'Overgrowth.exe' + 0x4ce90a (0x8ce90a)
uint8 _ANM_SWAP;		// 'Overgrowth.exe' + 0x4ce90b (0x8ce90b)
uint8 _ANM_FROM_START;		// 'Overgrowth.exe' + 0x4ce90c (0x8ce90c)
CharacterScriptGetter character_getter;		// 0x19a57cac
ReactionScriptGetter reaction_getter;		// 0x19a57c40
AttackScriptGetter attack_getter;		// 0x19a57c64
const int _high; // = 0
const int _medium; // = 1
const int _low; // = 2
const int _right; // = 0
const int _front; // = 1
const int _left; // = 2
AttackScriptGetter attack_getter2;		// 0x19a57c88
PathScriptReader path_script_reader;		// 0x19a57cc0
